/*
* Night Map
*			by
*				noskill;
*				AndrewZ.
*/

#include <amxmodx>
#include <amxmisc>

#define PLUGIN		"Night Map"
#define VERSION		"0.1 beta 4"
#define AUTHOR		"noskill and AndrewZ" 

new pcv_mapname
new pcv_mp_timelimit
new pcv_start_hour
new pcv_end_hour
new pcv_check_admin
new pcv_min_players
new pcv_lastround

new max_players

new bool:change_map

public plugin_cfg()
{
	new cfgdir[ 64 ]
	get_configsdir( cfgdir, 63 )
	
	server_cmd( "exec %s/nightmap/nightmap.cfg", cfgdir )
	
	new nightmap_commands[ 64 ]
	format( nightmap_commands, charsmax( nightmap_commands ), "%s/nightmap/nm_commands.ini", cfgdir )
	
	new commandsfile = fopen( nightmap_commands, "rt")
	new temp[ 128 ]
	new line = 0
	
	while( !feof( commandsfile ) )
	{
		fgets( commandsfile, temp, charsmax( temp ) )
		
		register_clcmd( temp, "cmd_BlockCmd" )
		line ++
	}
	
	fclose( commandsfile )
}

public plugin_init()
{
	register_plugin( PLUGIN, VERSION, AUTHOR )
	
	pcv_mapname =			register_cvar( "nm_mapname", 			"de_dust2" )
	pcv_mp_timelimit =		register_cvar( "nm_mp_timelimit", 		"40" )
	pcv_start_hour =		register_cvar( "nm_start_hour", 		"23" )
	pcv_end_hour =			register_cvar( "nm_end_hour", 			"7" )
	pcv_check_admin =		register_cvar( "nm_check_admin",		"0" )
	pcv_min_players =		register_cvar( "nm_min_players", 		"10" )
	pcv_lastround =			register_cvar( "nm_lastround", 			"1" )
	
	max_players = get_maxplayers()
	
	register_logevent( "event_Round_End", 		2, 		"1=Round_End" )
	register_logevent( "event_Round_Start", 	2, 		"1=Round_Start" )
	
	set_task( 1.0, "checkTime" )
	set_task( 60.0, "checkTime", _, _, _, "b" )
}

public cmd_BlockCmd( id )
{
	if( is_night_time() )
	{
		new current_time[ 6 ]
		get_time( "%H:%M", current_time, 5 )
		
		client_print( id, print_console, "[ %s ] Извините, эта команда отключена в ночное время!", PLUGIN )
		client_print( id, print_console, "[ %s ] Ночное время с %d:00 до %d:00, сейчас %s.", PLUGIN, get_pcvar_num( pcv_start_hour ), get_pcvar_num( pcv_end_hour ), current_time )
		client_printcolor( id, "^1[ ^4%s^1 ] Извините, эта команда отключена в ночное время!", PLUGIN )
		client_printcolor( id, "^1[ ^4%s^1 ] Ночное время с %d:00 до %d:00, сейчас %s.", PLUGIN, get_pcvar_num( pcv_start_hour ), get_pcvar_num( pcv_end_hour ), current_time )
		return PLUGIN_HANDLED
	}
	
	return PLUGIN_CONTINUE
}

public checkTime()
{
	new mp_timelimit = get_cvar_num( "mp_timelimit" )
	
	if( is_night_time() )
	{
		if( get_playersnum() <= get_pcvar_num( pcv_min_players ) )
		{
			if( mp_timelimit != 0 )
			{
				server_cmd( "mp_timelimit 0" )
			}
			
			if( !get_pcvar_num( pcv_lastround ) )
			{
				checkadmin_and_changemap()
			}
			else
			{
				change_map = true
			}
		}
	}
	else
	{
		if( mp_timelimit == 0 )
		{
			server_cmd( "mp_timelimit %d", get_pcvar_num( pcv_mp_timelimit ) )
		}
	}
}

public event_Round_End()
{
	if( get_pcvar_num( pcv_lastround ) == 1 )
	{
		if( change_map )
		{
			checkadmin_and_changemap()
		}
	}
}

public event_Round_Start()
{
	if( get_pcvar_num( pcv_lastround ) == 2 )
	{
		if( change_map )
		{
			checkadmin_and_changemap()
		}
	}
}

public checkadmin_and_changemap()
{
	if( is_night_time() ) 
	{
		new current_map[ 32 ]
		get_mapname( current_map, 31 )
		new map_name[ 32 ]
		get_pcvar_string( pcv_mapname, map_name, 31 )
		
		if( !equal( current_map, map_name ) )
		{
			if( !get_pcvar_num( pcv_check_admin ) )
			{
				client_printcolor( 0, "^1[ ^4%s^1 ] Смена карты через 10 секунд!", PLUGIN )
				set_task( 10.0, "changemap" )
			}
			else
			{
				if( !is_admin_on_server() )
				{
					client_printcolor( 0, "^1[ ^4%s^1 ] Смена карты через 10 секунд!", PLUGIN )
					set_task( 10.0, "changemap" )
				}
			}
		}
	}
}

public changemap()
{	
	new map_name[ 32 ]
	get_pcvar_string( pcv_mapname, map_name, 31 )
	server_cmd( "changelevel %s", map_name )
}

stock is_admin_on_server()
{
	for( new id = 1; id <= max_players; id ++ )
	{
		if( get_user_flags( id ) & ADMIN_MAP )
		{
			return 1
		}
	}
	
	return 0
}

stock is_night_time()
{
	new current_time[ 3 ], num_current_time
	
	get_time( "%H", current_time, 2 )
	
	num_current_time = str_to_num( current_time )
	
	new start_hour = get_pcvar_num( pcv_start_hour )
	new end_hour = get_pcvar_num( pcv_end_hour )

	if( ( num_current_time < start_hour && num_current_time < end_hour ) )
	{
		num_current_time += 24	
	}
	
	if( ( num_current_time > end_hour ) )
	{
		end_hour += 24
	}
	
	
	if( ( num_current_time >= start_hour ) && ( num_current_time < end_hour ) )
	{
		return 1
	}
	
	return 0
}

stock client_printcolor( const id, const input[], any:... )
{
	new count = 1, players[ 32 ]
	static msg[ 191 ]
	vformat( msg, 190, input, 3 )
    
	replace_all( msg, 190, "!g", "^4" ) // Green Color
	replace_all( msg, 190, "!n", "^1" ) // Default Color
	replace_all( msg, 190, "!t", "^3" ) // Team Color
    
	if( id ) players[ 0 ] = id; else get_players( players, count, "ch" )
	{
		for( new i = 0; i < count; i++ )
		{
			if( is_user_connected( players[ i ] ) )
			{
				message_begin( MSG_ONE_UNRELIABLE, get_user_msgid( "SayText" ), _, players[ i ] )
				write_byte( players[ i ] )
				write_string( msg )
				message_end()
			}
		}
	}
}